<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Function Types</TITLE>
<link href="suif1_65.html" rel=Next>
<link href="suif1_63.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_63.html">previous</A>, <A HREF="suif1_65.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC64" HREF="suif1_toc.html#TOC64">Function Types</A></H2>
<P>
<A NAME="IDX456"></A>
<A NAME="IDX457"></A>

</P>
<P>
<A NAME="IDX458"></A>
<A NAME="IDX459"></A>
<A NAME="IDX460"></A>
The <CODE>TYPE_FUNC</CODE> operator is used with the <CODE>func_type</CODE> derived
type class to describe the types of SUIF procedures.  A function type
includes the type of the return value and optionally the types of the
arguments as well.  The <CODE>return_type</CODE> and <CODE>set_return_type</CODE>
methods access the return type field.  The type system itself places no
restrictions on the return types, but the SUIF call and return
instructions do.  See section <A HREF="suif1_35.html#SEC35">Call Instructions</A>

</P>
<P>
<A NAME="IDX461"></A>
<A NAME="IDX462"></A>
<A NAME="IDX463"></A>
<A NAME="IDX464"></A>
Most of the complexity of function types involves the arguments.
Pointers to the argument types are stored in a dynamically-allocated
array.  The number of arguments, and thus the size of the array, is
stored in a field that can be accessed with the <CODE>num_args</CODE> and
<CODE>set_num_args</CODE> methods.  The number of arguments can be changed at
any time; if necessary the argument array will be reallocated.  The type
of a particular argument can be retrieved with the <CODE>arg_type</CODE>
method and set with the <CODE>set_arg_type</CODE> method.  The arguments are
numbered beginning with zero.

</P>
<P>
Argument types are under the same restrictions as result types of
instructions (see section <A HREF="suif1_26.html#SEC26">Result Types</A>) -- they must be object types with
known, non-zero size.

</P>
<P>
<A NAME="IDX465"></A>
<A NAME="IDX466"></A>
<A NAME="IDX467"></A>
Since functions can be declared in C without complete prototypes, a
function type may not be able to include any information about the
arguments.  This is indicated in a SUIF function type by the result of
the <CODE>args_known</CODE> method.  This flag can be set with the
<CODE>set_args_known</CODE> and <CODE>set_args_unknown</CODE> methods.  Setting
<CODE>args_known</CODE> FALSE sets the argument count to zero and the
<CODE>has_varargs</CODE> flag to FALSE.  Conversely, setting the argument
count to a non-zero value or the <CODE>has_varargs</CODE> flag to TRUE sets
the <CODE>args_known</CODE> flag to TRUE.

</P>
<P>
<A NAME="IDX468"></A>
<A NAME="IDX469"></A>
Some functions in C and other languages have a variable number of
arguments.  The SUIF function types support this by keeping a flag to
indicate if there may be additional arguments besides the ones that are
explicitly listed.  The <CODE>has_varargs</CODE> and <CODE>set_varargs</CODE>
methods access this flag.  Note that the <CODE>has_varargs</CODE> flag should
not be used if nothing else is known about the arguments.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_63.html">previous</A>, <A HREF="suif1_65.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
